FRICTION = .0002 -- defines the steepness of the spiral to the black hole

function love.load()
	math.randomseed(os.time())
	img_particle = love.graphics.newImage("particle.png")
	
	blackhole={}
	blackhole[1]={x=400,y=300,particle={}}
	for a=1,75 do
		local p={x=math.random(-200,200),y=math.random(-200,200)}
		local x,y = -p.y, p.x -- tangent vector
		local len = math.sqrt(x*x + y*y)
		local speed = math.random(20,100)
		p.vx = x/len * speed
		p.vy = y/len * speed
		p.direction = math.atan2(p.vy, p.vx)
		blackhole[1].particle[a] = p
	end
end

function love.update(dt)
	dt = math.min(dt, 1/75)
	for a=1,#blackhole[1].particle do
		local p = blackhole[1].particle[a]
		local dx,dy = -p.x, -p.y
		local len = math.sqrt(dx * dx + dy * dy)
		dx = dx / len
		dy = dy / len

		local pull = 50 / (len/100 + .01) * dt
		p.vx = p.vx * (1 - FRICTION) + pull * dx
		p.vy = p.vy * (1 - FRICTION) + pull * dy

		p.x = p.x + p.vx * dt
		p.y = p.y + p.vy * dt

		p.direction=math.atan2(p.vy,p.vx)
	end
end

-- poor mans motion blur
function love.graphics.clear()
	love.graphics.setColor(0,0,0,12)
	love.graphics.rectangle('fill', 0,0, love.graphics.getWidth(), love.graphics.getHeight())
end

function love.draw()
	love.graphics.setColor(255,220,190,255)
	for a=1,#blackhole[1].particle do
		local p = blackhole[1].particle[a]
		local size = math.pow(p.x*p.x + p.y*p.y, .3) / 20
		love.graphics.draw(img_particle,blackhole[1].x+p.x,blackhole[1].y+p.y,p.direction,size,size,32,32)
	end
end
